<?php

include_once 'payment.paygine.lib.php';

Paygine::checkCms();
class Payment_paygine_model extends Diafan
{
	public function get($params, $pay)
	{
		$paygine = new Paygine($this->diafan, $pay['payment_id']);
		// if "sending an invoice" is checked
		if(!empty($paygine->notify_customer)){
			// updating order status
			$paygine->diafan = $this->diafan;
			$paygine->updateOrderStatus($pay['element_id'], $paygine->order_agreement);
			$user_id = DB::query_result("SELECT user_id FROM {shop_order} WHERE id=%d LIMIT 1", $pay['element_id']);
			$order_button = '';
			if($user_id){
				$user_name = DB::query_result("SELECT name FROM {users} WHERE id=%d  AND trash='0' LIMIT 1", $user_id);
				$order_button = '<p>
					<a class="button-d" style="margin-top: 1.66rem" href="' . BASE_PATH . 'user/?name=' . $user_name . '">Заказы</a>
				</p>';
			}
			
			return [
				'text' => '<p>Заказ оформлен. Для подтверждения и оплаты с вами свяжется менеджер.</p>' . $order_button
			];
		}
		
		try {
			$pg_order_id = $paygine->registerOrder($pay);
		} catch(Exception $e) {
			Dev::exception($e, 'error');
			return ['text' => $e->getMessage()];
		}
		
		if(!empty($paygine->order_registered))
			$paygine->updateOrderStatus($pay['element_id'], $paygine->order_registered);
		
		$paygine->addPcOrderParams($pay['element_id'], [
			'id' => $pg_order_id,
			'payment_id' => $pay['payment_id'],
			'payment_type' => '',//$paygine->payment_type,
			'amount' => '',//$order_amount,
			'currency' => Paygine::DEFAULT_CURRENCY_ISO,
			'order_state' => Paygine::ORDER_REGISTERED
		]);
		
		$args = [
			'id' => $pg_order_id,
			'sector' => $paygine->sector
		];
		
		$shop_cart = $paygine->calcShopCart($pay);
		$shop_cart_encoded = '';
		if($shop_cart && ($paygine->payment_type === 'halva' || $paygine->payment_type === 'halva_two_steps')) {
			$shop_cart_encoded = base64_encode(json_encode($shop_cart, JSON_UNESCAPED_UNICODE));
			if(strlen($shop_cart_encoded) > Paygine::SHOP_CART_MAX_LENGTH)
				$shop_cart_encoded = '';
			$args['shop_cart'] = $shop_cart_encoded;
		}
		
		$args['signature'] = $paygine->generateSign($paygine->sector . $pg_order_id . $shop_cart_encoded, true);
		$payment_url = $paygine->getUrl() . Paygine::PAYMENT_TYPES_PATHS[$params['paygine_payment_type']];
		return [
			'text' => $pay['text'],
			'args' => $args,
			'payment_url' => $payment_url,
			'redirect' => (!empty($params['paygine_redirect'])),
			'modal' => (!empty($params['paygine_modal'])),
			'modal_url' => $payment_url . '?' . http_build_query($args),
			'paygine_url' => $paygine->getUrl()
		];
	}
}
